#include <ogr_api.h>
#include <cpl_conv.h>
#include <string>
#include <iostream>
#include <cassert>
using namespace std;


int main()
{
    OGRRegisterAll();

    std::string shp("test.shp");

    OGRDataSourceH ds = OGROpen(shp.c_str(), 0, NULL);
    assert(0 != ds && "Can not open shp");
    

    const char* sql = "SELECT DISTINCT id FROM test ORDER BY id";

    OGRLayerH lyr = OGR_DS_ExecuteSQL(ds, sql, NULL, "SQL");
    assert(0 != lyr && "Layer is null");

    OGRFeatureH f;
    while (f = OGR_L_GetNextFeature(lyr))
    {
        cout << OGR_F_GetFieldAsInteger(f, 0) << endl;
        OGR_F_Destroy(f);
    }

    OGR_DS_ReleaseResultSet(ds, lyr);
    OGR_DS_Destroy(ds);

    return 0;
}

